import {
  select,
  json,
  tsv,
  geoPath,//data path to svg path
  geoEquirectangular,
  //geoMercator,
  zoom,
  event,
  csv,
  scaleOrdinal,
  schemeRdYlGn
  
} from 'd3';
import {loadAndProcessData} from './loadAndProcessData';

import {colorLegend} from './colorLegend';

const svg = select('svg');


/*let selectcountry=null;
const onClick= id=>{selectcountry=id;
render();};
*/


const projection = geoEquirectangular(); //changed map  
const pathGenerator = geoPath().projection(projection);














const g = svg.append('g');

const colorLegendG=svg.append('g')
    .attr('transform', `translate(20,240)`);

g.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

svg.call(zoom().on('zoom', () => {
  g.attr('transform', event.transform);
}));



const colorScale=scaleOrdinal();

const colorValue=d=>d.properties.economy;



loadAndProcessData().then(countries=>{
  
  colorScale
    .domain(countries.features.map(colorValue))
    .domain(colorScale.domain().sort().reverse())
    .range(schemeRdYlGn[colorScale.domain().length]);
  
  
  colorLegendG
    .call(colorLegend, {
      colorScale,
      circleRadius: 10,
      spacing: 25,
      textOffset: 15,
    backgroundRectWidth:250
    });

  
  
  
  
  
  
  
  g.selectAll('path').data(countries.features)
    .enter().append('path')
      .attr('class', 'country')
      .attr('d', pathGenerator)
      .attr('fill',d=>colorScale(colorValue(d)))
    .append('title')
  .text(d=>d.properties.name+': ' + d.properties.primary_balance);
      //.text(detail);
  
 
});